#include <TimerOne.h>

#define PWM_OUT 10
#define FEEDBACK  A0
#define MAX_DUTY 950

float voltage;
float set_voltage=12.5;
float error;
float pwm_duty;
float kp=300;

void setup() {
    // Initializes Timer1 to overflow in 1 microsecond periods (1MHz)
    // 1/period=frequency
    Timer1.initialize(10);
    // Enables PWM on pin 10 with 50% duty cycle
    // This function expects a 10 bit value for duty cycle. I.E. a value between 0 (which is 0%) and 1024 (which is 100%)
    Timer1.pwm(PWM_OUT, 50);
    Serial.begin(9600);
}

void loop() {
    //delay(1);
    voltage = (float)analogRead(FEEDBACK) * 0.01466;
    error = set_voltage-voltage;
    pwm_duty=error*kp+pwm_duty;
    if(pwm_duty<0)  pwm_duty=0;
    if(pwm_duty>MAX_DUTY) pwm_duty=MAX_DUTY;
    Timer1.setPwmDuty(PWM_OUT, (int)pwm_duty);
    Serial.print("Voltage:");
    Serial.print(voltage);
    Serial.print("V Error:");
    Serial.print(error);
    Serial.print("V Duty:");
    Serial.println(pwm_duty);
}

