#include <TimerOne.h>

#define PWM_OUT 10
#define SENSOR  A0
#define MAX_DUTY 1024

float sensor;
float set_sensor=1;
float error;
float pwm_duty;
float kp=300;

void setup() {
    // Initializes Timer1 to overflow in 1 microsecond periods (1MHz)
    // 1/period=frequency
    Timer1.initialize(1);
    // Enables PWM on pin 10 with 50% duty cycle
    // This function expects a 10 bit value for duty cycle. I.E. a value between 0 (which is 0%) and 1024 (which is 100%)
    Timer1.pwm(PWM_OUT, 50);
    Serial.begin(9600);
}

void loop() {
    //delay(1);
    sensor = (float)analogRead(SENSOR);// * 0.01466;
    error = set_sensor-sensor;
    pwm_duty=error*kp+pwm_duty;
    if(pwm_duty<0)  pwm_duty=0;
    if(pwm_duty>MAX_DUTY) pwm_duty=MAX_DUTY;
    Timer1.setPwmDuty(PWM_OUT, (int)pwm_duty);
    Serial.print("Sensor:");
    Serial.print(sensor);
    Serial.print(" | Error:");
    Serial.print(error);
    Serial.print(" | Duty:");
    Serial.println(pwm_duty);
}

